type SafeKey<T> = T extends string | number ? `${T}` : never;
type Paths<O, P = ''> = O extends object ? {
    [K in keyof O]: (P extends '' ? K : `${SafeKey<P>}.${SafeKey<K>}`) | Paths<O[K], P extends '' ? K : `${SafeKey<P>}.${SafeKey<K>}`>;
}[keyof O] : never;

declare function createInstance<T>(locales: T, initialLanguage: keyof T): {
    t: (key: Paths<T[keyof T]>, replaceStrings?: Record<string, string | number>) => string;
    language: keyof T;
    avaliableLanguages: (keyof T)[];
    setLanguage: (_language: keyof T) => void;
};

export { createInstance };
